/* definition of a struct to hold RBTvalue informations, 
 * the main value is sig_id but this depends on sig_rev and
 * sig_prio. therefore a linked list can be added for further
 * cached values for the same sig_sid
 */
/***************************************************************/
typedef struct _RBTvalue
{
  int sig_id;
  int sig_rev;
  int sig_prio;
  struct _RBTvalue * next;
} RBTvalue;

/* type of key, should be short/int/long/... */
typedef int RBTkey;

/***************************************************************/

/* node definition for a red-black tree*/
typedef struct _RBTnode
{
  struct _RBTnode * parent;
  struct _RBTnode * right;
  struct _RBTnode * left;
  int color;
  /* this is the key */
  RBTkey key;
  /* this is a pointer to the struct containing further
   * informations and the cached value(s)
   */
  RBTvalue * value;
} RBTnode;

/* simple definition of a red-black tree */
typedef struct _RBTree
{
  struct _RBTnode * root; 
} RBTree;

/****** function prototypes ******/
RBTnode * FindNode(RBTree *T, int *res, RBTkey key);
int PrintRBTree(RBTnode *x);
int InsertRBTnode(RBTree *T, RBTkey key,RBTvalue *value, RBTnode* parent);
